#include "map.h"

Map* new_map() {

	gint i,j;
	Map* new = (Map*) g_malloc(sizeof(Map));

	new->name = g_string_new("new map");
	new->id = 0;

	for(j=0;j<MAX_MAP_Y;j++)
	for(i=0;i<MAX_MAP_X;i++)
		new->cell[i][j] = new_space();

	new->update = g_list_alloc();
	new->area_ox = 0;
	new->area_oy = 0;

	return new;

}

void zap_map(Map* map) {

	gint i,j;

	if(map != NULL) {

		if(map->name != NULL) {
		
			g_string_free(map->name,TRUE);
			map->name = NULL;
		
		}		

		for(j=0;j<MAX_MAP_Y;j++)
		for(i=0;i<MAX_MAP_X;i++)
			if(map->cell[i][j] != NULL) {

				zap_space(map->cell[i][j]);

			}

		if(map->update != NULL) {

			g_list_foreach(map->update,zap_coords,NULL);
			g_list_free(map->update);
		
		}

		g_free(map);
		map = NULL;

	}

}

Space* new_space() {
	
	Space* new = (Space*) g_malloc(sizeof(Space));

	new->properties = (0x0000);
	new->variation = 0;
	new->access = 0;
	new->mos = g_list_alloc();
	new->ios = g_list_alloc();

	return new;

}

void zap_space(Space* space) {
	
	if(space != NULL) {
	
		if(space->mos != NULL) {
	
			g_list_foreach(space->mos,zap_monster,NULL);
			g_list_free(space->mos);
	
		}
	
		if(space->ios != NULL) {
	
			g_list_foreach(space->ios,zap_item,NULL);
			g_list_free(space->ios);
	
		}
	
		g_free(space);
		space = NULL;

	}

}

Coords* new_coords() {
	
	Coords* new = (Coords*) g_malloc(sizeof(Coords));

	new->x = 0;
	new->y = 0;

	return new;

}

void zap_coords(Coords* coords) {

	if(coords != NULL) {

		g_free(coords);
		coords = NULL;

	}

}
