#include "sprite.h"

Sprite* new_sprite() {

	Sprite* new = (Sprite*) g_malloc(sizeof(Sprite));

	new->image = NULL;
	new->pixmap = NULL;
	new->mask = NULL;

	return new;

}

void zap_sprite(Sprite* sprite) {

	if(sprite != NULL) {

		if(sprite->image != NULL) {

			g_free(sprite->image);
			sprite->image = NULL;

		}

		if(sprite->pixmap != NULL) {

			g_free(sprite->pixmap);
			sprite->pixmap = NULL;
		
		}

		if(sprite->mask != NULL) {

			g_free(sprite->mask);
			sprite->mask = NULL;
		
		}

		g_free(sprite);
		sprite = NULL;

	}

}

void init_image_files(GameControl* gamec) {
	
	gamec->image_files = g_list_append(gamec->image_files,	"./images/intro_screen.jpg"	); /* INTRO_SCREEN	(1) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/logo.jpg"		); /* QUEST_LOGO	(2) */

}

void init_sprites(GameControl* gamec) 
{

	init_image_files(gamec);
	g_list_foreach(gamec->image_files,load,gamec);

}

void load(gpointer data,GameControl* gamec) {

	if(data != NULL) {

		Sprite* sprite = new_sprite();
		g_print("loading: %s\n",data);

		sprite->image = gdk_imlib_load_image(data);
		gdk_imlib_render(sprite->image,sprite->image->rgb_width,sprite->image->rgb_height);
		sprite->pixmap = gdk_imlib_copy_image(sprite->image);
		sprite->mask = gdk_imlib_copy_image(sprite->image);

		gamec->sprites = g_list_append(gamec->sprites,sprite);

	}

}