#include "xfuncs.h"

void init_widgets(GameControl* gamec) {

	GtkWidget *map_window;
	GtkWidget *map_box;
	GtkWidget *map_pixmap;
	GtkWidget *test_button;

	map_pixmap = gtk_pixmap_new(PIXMAP(QUEST_LOGO),NULL);

	map_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(map_window),QUEST_WINDOW_TITLE);
	gtk_signal_connect(GTK_OBJECT(map_window),"delete_event",GTK_SIGNAL_FUNC(delete_event),NULL); 
	gtk_signal_connect(GTK_OBJECT(map_window),"destroy",GTK_SIGNAL_FUNC(destroy),NULL);
	gtk_container_set_border_width(GTK_CONTAINER(map_window),0);
	
	map_box = gtk_vbox_new(FALSE,0);
	
	gtk_box_pack_start(GTK_BOX(map_box),map_pixmap,TRUE,TRUE,0);
	gtk_widget_show(map_pixmap);
	
	test_button = gtk_button_new_with_label("pull my tail");
	gtk_signal_connect(GTK_OBJECT(test_button),"clicked",GTK_SIGNAL_FUNC(button_clicked),NULL);
	gtk_box_pack_start(GTK_BOX(map_box),test_button,TRUE,TRUE,0);
	gtk_widget_show(test_button);
	
	gtk_container_add(GTK_CONTAINER(map_window),map_box);
	gtk_widget_show(map_box);
	
	gtk_widget_show(map_window);

	g_timeout_add(GAME_CYCLE_TIME,do_cycle,gamec);

}

gint delete_event(GtkWidget *widget,GdkEvent *event,gpointer data) {

	g_print("delete event occurred\n");

	/* turn TRUE into FALSE and the window will get destroyed */
	return FALSE;

}
                    
void destroy(GtkWidget *widget,gpointer data) {

	gtk_main_quit ();

}

void button_clicked(GtkWidget *widget,gpointer data) {

	g_print ( "moo!\n" );

}
